To add *All Accounts* as a dependency
add the following to your addon's addon.xml file between the `<requires></requires>` tag.

`<import addon="script.module.allaccounts" version="1.0.0" />`
Addon developers can access *All Accounts* as simply as

# How to call *All Accounts* settings 

You can use `import allaccounts` once the dependecy is added to your addon.  The following lists the functions that can be called that will respond with a dictionary and the supplied key and value.

### allaccount.getAll()
This function call will provide all available accounts as a dictionary for each account handled.  If we called `accounts = allaccounts.getAll()` The returned data will be as follows.
`accounts ={'premiumize': {'enabled': '', username': '', 'token': ''}, 'alldebrid': {'enabled': '', 'username': '', 'token': ''}, 'tmdb': {'username': '', 'password': '', 'api_key': '', 'session_id': ''},
	'realdebrid': {'enabled': '', 'username': '', 'token': '', 'secret': '', 'refresh': '', 'client_id': ''}, 'ororo': {'password': '', 'email': ''}, 'tvdb': {'api_key': ''}, 'filepursuit': {'api_key': ''},
	'trakt': {'username': '', 'token': '', 'expires': '', 'refresh': ''}, 'imdb': {'user': ''}, 'easyNews': {'username': '', 'password': ''}, 'furk': {'username': '', 'api_key': '', 'password': ''},
	'fanart_tv': {'api_key': ''}}`

### allaccount.getTrakt()
Returns trakt only account info
```trakt': {'username': '', 'token': '', 'expires': '', 'refresh': ''}```

### allaccount.getAllDebrid()
Returns all debrid account information supported (currently All-Debrid, Premiumize.me, Real-Debrid)
There is an addional key for each dictionary `'enabled'`.  This key could be used by the adon developer that the debrid service is temporarily disabled by the user.
`{premiumize': {'enabled': '', 'username': '', 'token': ''}, 'alldebrid': {'enabled': '', 'username': '', 'token': ''}, 'realdebrid': {'enabled': '', 'username': '', 'token': '', 'secret': '', 'refresh': '', 'client_id': ''}}`

### allaccount.getAD()
`alldebrid': {'enabled': '', 'username': '', 'token': ''}`
 
### allaccount.getPM()
`premiumize': {'enabled': '', 'username': '', 'token': ''}`
  
### allaccount.getRD()
`realdebrid': {'enabled': '', 'username': '', 'token': '', 'secret': '', 'refresh': '', 'client_id': ''}`

### allaccount.getAllMeta()
`{'tmdb': {'username': '', 'password': '', 'api_key': '', 'session_id': ''}, 'tvdb': {'api_key': ''}, 'imdb': {'user': ''}, 'fanart_tv': {'api_key': ''}}`

### allaccount.getFanart_tv()
`fanart_tv': {'api_key': ''}`

### allaccount.getTMDb()
`tmdb': {'username': '', 'password': '', 'api_key': '', 'session_id': ''}`

### allaccount.getTVDb()
`tvdb': {'api_key': ''}`

### allaccount.getIMDb()
`imdb': {'user': ''}`

### getAllScraper()
`{'ororo': {'password': '', 'email': ''}, 'filepursuit': {'api_key': ''}, 'easyNews': {'username': '', 'password': ''}, 'furk': {'username': '', 'api_key': '', 'password': ''}}`

### getFilepursuit()
`filepursuit: {'api_key': ''}`

### allaccount.getFurk()
`furk: {'username': '', 'api_key': '', 'password': ''}`

### allaccount.getEasyNews()
`easyNews: {'username': '', 'password': ''}`

### allaccount.getOrro()
`ororo: {'password': '', 'email': ''}`
